"""the node of the renderfarm
Edward Cannon made this, please give credit where credit is due"""
UPLOADURL = "http://127.0.0.1/upload.py" #the url to upload the file to

import subprocess, os
import urllib, urllib2

def escape(x):
    """escape a path in a java safe way"""
    out = ""
    for k in x:
        if k == "\\": out = out+"\\\\"
        else: out = out + k
    return out

infile = open("autorenderPRE.bsh")
data = infile.read()
infile.close()
outfile = open("AOI\Scripts\Startup\loadfile.bsh", "w")
configfile = open("config.txt")
#generate startupscript
for line in configfile:
    if line.startswith("#"): #comment line, ignore
        continue
    temp = line.split(None, 1)
    if len(temp) == 0: #empty line, ignore
        continue
    value = temp[1].replace("$ROOT$", escape(os.getcwd())).strip()
    data = data.replace(temp[0], value)
configfile.close()
outfile.write(data)
outfile.close()
#render file
os.chdir("AOI")
subprocess.call("java -jar ArtOfIllusion.jar")
#upload file
os.chdir("..")
for fname in os.listdir("render"):
    print fname
    f = open(os.path.join("render", fname), "rb")
    form = urllib.urlencode({"filename": fname, "file":f.read()})
    req = urllib2.Request(UPLOADURL, data=form)
    #print req
    #print urllib2.urlopen(req).read()
    f.close()



###wait to be closed, debug only
##import time
##while True:
##    time.sleep(1)
